// 004 xxx
// 05 nov 2007

// -- Copyright (C) Felix John COLIBRI 2004 - All Rigths Reserved
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit Default;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Web.Security, System.Web.UI.WebControls.WebParts, System.Configuration,
  Borland.Data.DataStore, Borland.Data.AdoDbxClientProvider
        , System.Web.Profile
        ;

type
  TDefault = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure clear_display__Click(sender: System.Object; e: System.EventArgs);
    procedure get_all_profiles_info__Click(sender: System.Object; e: System.EventArgs);
    procedure list_user_profile_info__Click(sender: System.Object; e: System.EventArgs);
    procedure get_property_default_value__Click(sender: System.Object; e: System.EventArgs);
    procedure get_property_value__Click(sender: System.Object; e: System.EventArgs);
    procedure list_property_names__Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    TextBox1: System.Web.UI.WebControls.TextBox;
    add_profile_: System.Web.UI.WebControls.Button;
    userid_textbox_: System.Web.UI.WebControls.TextBox;
    list_profile_: System.Web.UI.WebControls.Button;
    street_textbox_: System.Web.UI.WebControls.TextBox;
    clear_display_: System.Web.UI.WebControls.Button;
    drop_profile_: System.Web.UI.WebControls.Button;
    drop_membership_: System.Web.UI.WebControls.Button;
    create_usersinprofile_: System.Web.UI.WebControls.Button;
    add_userinprofile_: System.Web.UI.WebControls.Button;
    delete_usersinprofile_: System.Web.UI.WebControls.Button;
    drop_usersinprofile_: System.Web.UI.WebControls.Button;
    list_usersinprofile_: System.Web.UI.WebControls.Button;
    user_listbox_: System.Web.UI.WebControls.ListBox;
    list_users_: System.Web.UI.WebControls.Button;
    name_textbox_: System.Web.UI.WebControls.TextBox;
    city_textbox_: System.Web.UI.WebControls.TextBox;
    zip_textbox_: System.Web.UI.WebControls.TextBox;
    state_textbox_: System.Web.UI.WebControls.TextBox;
    get_all_profiles_info_: System.Web.UI.WebControls.Button;
    list_user_profile_info_: System.Web.UI.WebControls.Button;
    username_textbox_: System.Web.UI.WebControls.TextBox;
    get_property_default_value_: System.Web.UI.WebControls.Button;
    get_property_value_: System.Web.UI.WebControls.Button;
    list_property_names_: System.Web.UI.WebControls.Button;
    property_name_textbox_: System.Web.UI.WebControls.TextBox;
  protected
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
  public
    procedure display(p_text: String);
    procedure clear_display;
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TDefault.InitializeComponent;
begin
  Include(Self.clear_display_.Click, Self.clear_display__Click);
  Include(Self.get_all_profiles_info_.Click, Self.get_all_profiles_info__Click);
  Include(Self.list_user_profile_info_.Click, Self.list_user_profile_info__Click);
  Include(Self.get_property_default_value_.Click, Self.get_property_default_value__Click);
  Include(Self.get_property_value_.Click, Self.get_property_value__Click);
  Include(Self.list_property_names_.Click, Self.list_property_names__Click);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

    procedure TDefault.display(p_text: String);
      begin
        TextBox1.Text:= TextBox1.Text+ p_text+ chr(13)+ chr(10);
      end; // display

    procedure TDefault.clear_display;
      begin
        TextBox1.Text:= '';
      end; // clear_display

    procedure TDefault.OnInit(e: EventArgs);
      begin
        //
        // Required for Designer support
        //
        InitializeComponent;
        inherited OnInit(e);
      end; // OnInit

    procedure TDefault.Page_Load(sender: System.Object; e: System.EventArgs);
      begin
        // TODO: Put profile code to initialize the page here
      end; // Page_Load

    procedure TDefault.clear_display__Click(sender: System.Object; e: System.EventArgs);
      begin
        clear_display;
      end; // clear_display__Click

    // -- using profiles

    procedure TDefault.get_all_profiles_info__Click(sender: System.Object; e: System.EventArgs);
      var l_c_profile_info_collection: ProfileInfoCollection;
          l_profile_count: Integer;
          l_i_user_enumerator: iEnumerator;
      begin
        display('> get_all_profiles_info');
{
        l_c_profile_info_collection:= GetAllProfiles(ProfileAuthenticationOption.All,
            0, 10, l_profile_count);
}
        l_c_profile_info_collection:= ProfileManager.GetAllProfiles(ProfileAuthenticationOption.All,
            0, 10, l_profile_count);
(*
        for l_profile_info_index:= 0 to l_c_profile_info_collection.Count- 1 do
          with l_c_profile_info_collection.Item[l_profile_info_index] do
            display(UserName);
*)
        display('count '+ l_c_profile_info_collection.Count.ToString);

        l_i_user_enumerator:= l_c_profile_info_collection.GetEnumerator;
        while l_i_user_enumerator.MoveNext do
          with l_i_user_enumerator.Current as ProfileInfo do
            display(UserName);
        display('< get_all_profiles_info');
      end; // get_all_profiles_info__Click

    procedure TDefault.list_user_profile_info__Click(sender: System.Object; e: System.EventArgs);
      var l_c_profile_info_collection: ProfileInfoCollection;
          l_profile_count: Integer;
          l_i_user_enumerator: iEnumerator;
      begin
        l_c_profile_info_collection:= ProfileManager.FindProfilesByUserName(ProfileAuthenticationOption.All,
            username_textbox_.Text,
            0, 10, l_profile_count);

        display('count '+ l_c_profile_info_collection.Count.ToString);

        l_i_user_enumerator:= l_c_profile_info_collection.GetEnumerator;
        while l_i_user_enumerator.MoveNext do
          with l_i_user_enumerator.Current as ProfileInfo do
            display(UserName);
      end; // list_user_profile_info__Click

    // -- property name and value

    procedure TDefault.list_property_names__Click(sender: System.Object; e: System.EventArgs);
      var l_c_profile_base: ProfileBase;
          l_i_enumerator: iEnumerator;
          l_c_settings_property: SettingsProperty;
      begin
        l_c_profile_base:= HttpContext.Current.Profile;

        l_i_enumerator:= l_c_profile_base.Properties.GetEnumerator;
        while l_i_enumerator.MoveNext do
        begin
          l_c_settings_property:= l_i_enumerator.Current as SettingsProperty;
          display(l_c_settings_property.Name);
        end;
      end; // list_property_names__Click

    procedure TDefault.get_property_default_value__Click(sender: System.Object; e: System.EventArgs);
      var // l_c_profile_base: ProfileBase;
          // l_property_index: Integer;
          l_i_property_enumerator: iEnumerator;
          l_c_settings_property: SettingsProperty;
          l_property_name: String;
          l_property_default_value: String;
      begin
        // l_c_profile_base:= Page.Profile.GetProfile(username_textbox_.Text);
        // l_c_profile_base:= HttpContext.&Profile;

        // l_property_default_value:= l_c_profile_base.GetPropertyValue('Street') as String;
        // display(Page.Profile.Street);

        // this gets the DEFAULT values of Web.Config
        display('default.prop.Count '+ DefaultProfile.Properties.Count.ToString);

        l_property_name:= property_name_textbox_.Text;
        if DefaultProfile.Properties.Count> 0
          then begin
              if assigned(DefaultProfile.Properties.Item[l_property_name])
                then l_property_default_value:= DefaultProfile.Properties.Item[l_property_name].DefaultValue.ToString
                else display('no_'+ l_property_name);
              display(l_property_name+ '_default_value '+ l_property_default_value);
            end
          else display('count < 0');

(*
        for l_property_index:= 0 to DefaultProfile.Properties.Count- 1 do
          display(DefaultProfile.Properties.Item[l_property_index].ToString);
*)
        l_i_property_enumerator:= DefaultProfile.Properties.GetEnumerator;
        while l_i_property_enumerator.MoveNext do
        begin
(*
          with l_i_property_enumerator.Current do
            display(UserName);
*)
          // display(l_i_property_enumerator.Current.ToString);
          l_c_settings_property:= l_i_property_enumerator.Current as SettingsProperty;
          // display(l_c_settings_property.Name+ ' '+ l_c_settings_property.Value.ToString);
        end; // while l_i_property_enumerator

        // the Name display('Def.tostring '+ DefaultProfile.Properties.ToString);
      end; // get_property_default_value__Click

    procedure TDefault.get_property_value__Click(sender: System.Object; e: System.EventArgs);
      var l_c_profile_base: ProfileBase;
          // l_c_SettingsPropertyValueCollection: SettingsPropertyValueCollection;
          l_property_name: String;
          l_property_value: String;
          l_user_name: String;
      begin
        l_property_name:= property_name_textbox_.Text;

        // no "profile" display(Profile.Street);
        // display(Profile.Street);
        // l_c_profile_base:= Page.Profile.GetProfile(username_textbox_.Text);
        l_c_profile_base:= HttpContext.Current.Profile;
        l_property_value:= l_c_profile_base.GetPropertyValue(l_property_name).ToString;
        display(l_property_name+ ' is '+ l_property_value);
        // display(ProfileBase.GetPropertyValue('Street').ToString);

        // l_c_SettingsPropertyValueCollection:= DefaultProfile.GetPropertyValues
        l_user_name:= User.Identity.Name;
        l_c_profile_base:= ProfileBase.&Create(l_user_name); // 'user_1');
        l_property_value:= l_c_profile_base.GetPropertyValue(l_property_name).ToString;
        display('user '+ l_user_name+ ' '+ l_property_name+ ' is '+ l_property_value);
        // display(l_c_profile_base.PropertyName);
      end; // get_property_value__Click

    end.



